package data;

public enum CalculateFor {
	WORD("različnica"),
	NORMALIZED_WORD("normalizirana različnica"),
	LEMMA("lema"),
	MORPHOSYNTACTIC_SPECS("oblikoskladenjska oznaka"),
	MORPHOSYNTACTIC_PROPERTY("oblikoskladenjska lastnost"),
	WORD_TYPE("besedna vrsta"),
	DIST_WORDS("različnica"),
	DIST_LEMMAS("lema");


	private final String name;

	CalculateFor(String name) {
		this.name = name;
	}

	public String toString() {
		return this.name;
	}

	public static CalculateFor factory(String cf) {
		if (cf != null) {
			if (WORD.toString().equals(cf)) {
				return WORD;
			}
			if (LEMMA.toString().equals(cf)) {
				return LEMMA;
			}
			if (MORPHOSYNTACTIC_SPECS.toString().equals(cf)) {
				return MORPHOSYNTACTIC_SPECS;
			}
			if (MORPHOSYNTACTIC_PROPERTY.toString().equals(cf)) {
				return MORPHOSYNTACTIC_PROPERTY;
			}
			if (WORD_TYPE.toString().equals(cf)) {
				return WORD_TYPE;
			}
			if (NORMALIZED_WORD.toString().equals(cf)) {
				return NORMALIZED_WORD;
			}
		}
		return null;
	}

	public String totalSumString(int ngram) {
		if (ngram == 0) {
			switch (this) {
				case WORD:
					return "Skupna vsota vseh črkovnih nizov različnic:";
				case NORMALIZED_WORD:
					return "Skupna vsota vseh črkovnih nizov normaliziranih različnic:";
				case LEMMA:
					return "Skupna vsota vseh črkovnih nizov lem:";
				case MORPHOSYNTACTIC_SPECS:
					return "Skupna vsota vseh črkovnih nizov oblikoskladenjskih oznak:";
				case MORPHOSYNTACTIC_PROPERTY:
					return "Skupna vsota vseh črkovnih nizov oblikoskladenjskih lastnosti:";
				case WORD_TYPE:
					return "Skupna vsota vseh črkovnih nizov besednih vrst:";
				case DIST_WORDS:
					return "Skupna vsota vseh črkovnih nizov različnic:";
				case DIST_LEMMAS:
					return "Skupna vsota vseh črkovnih nizov lem:";
				default:
					return null;
			}
		} else if (ngram >= 1) {
			switch (this) {
				case WORD:
					return "Skupna vsota vseh različnic:";
				case NORMALIZED_WORD:
					return "Skupna vsota vseh normaliziranih različnic:";
				case LEMMA:
					return "Skupna vsota vseh lem:";
				case MORPHOSYNTACTIC_SPECS:
					return "Skupna vsota vseh oblikoskladenjskih oznak:";
				case MORPHOSYNTACTIC_PROPERTY:
					return "Skupna vsota vseh oblikoskladenjskih lastnosti:";
				case WORD_TYPE:
					return "Skupna vsota vseh besednih vrst:";
				case DIST_WORDS:
					return "Skupna vsota vseh različnic:";
				case DIST_LEMMAS:
					return "Skupna vsota vseh lem:";
				default:
					return null;
			}
		}
		return null;
	}

	public String foundSumString(int ngram) {
		if (ngram == 0) {
			switch (this) {
				case WORD:
					return "Skupna vsota vseh najdenih črkovnih nizov različnic:";
				case NORMALIZED_WORD:
					return "Skupna vsota vseh najdenih črkovnih nizov normaliziranih različnic:";
				case LEMMA:
					return "Skupna vsota vseh najdenih črkovnih nizov lem:";
				case MORPHOSYNTACTIC_SPECS:
					return "Skupna vsota vseh najdenih črkovnih nizov oblikoskladenjskih oznak:";
				case MORPHOSYNTACTIC_PROPERTY:
					return "Skupna vsota vseh najdenih črkovnih nizov oblikoskladenjskih lastnosti:";
				case WORD_TYPE:
					return "Skupna vsota vseh najdenih črkovnih nizov besednih vrst:";
				case DIST_WORDS:
					return "Skupna vsota vseh najdenih črkovnih nizov različnic:";
				case DIST_LEMMAS:
					return "Skupna vsota vseh najdenih črkovnih nizov lem:";
				default:
					return null;
			}
		} else if (ngram >= 1) {
			switch (this) {
				case WORD:
					return "Skupna vsota vseh najdenih različnic:";
				case NORMALIZED_WORD:
					return "Skupna vsota vseh najdenih normaliziranih različnic:";
				case LEMMA:
					return "Skupna vsota vseh najdenih lem:";
				case MORPHOSYNTACTIC_SPECS:
					return "Skupna vsota vseh najdenih oblikoskladenjskih oznak:";
				case MORPHOSYNTACTIC_PROPERTY:
					return "Skupna vsota vseh najdenih oblikoskladenjskih lastnosti:";
				case WORD_TYPE:
					return "Skupna vsota vseh najdenih besednih vrst:";
				case DIST_WORDS:
					return "Skupna vsota vseh najdenih različnic:";
				case DIST_LEMMAS:
					return "Skupna vsota vseh najdenih lem:";
				default:
					return null;
			}
		}

		return null;
	}

	public String totalAbsoluteFrequencyString(int ngram) {
		if (ngram == 0) {
			return "Skupna absolutna pogostost črkovnega niza";
		}
		switch(this){
			case WORD:
				return "Skupna absolutna pogostost različnice";
			case NORMALIZED_WORD:
				return "Skupna absolutna pogostost normalizirane različnice";
			case LEMMA:
				return "Skupna absolutna pogostost leme";
			case MORPHOSYNTACTIC_SPECS:
				return "Skupna absolutna pogostost oblikoskladenjske oznake";
			case MORPHOSYNTACTIC_PROPERTY:
				return "Skupna absolutna pogostost oblikoskladenjske lastnosti";
			case WORD_TYPE:
				return "Skupna absolutna pogostost besedne vrste";
			case DIST_WORDS:
				return "Skupna absolutna pogostost različnice";
			case DIST_LEMMAS:
				return "Skupna absolutna pogostost leme";
			default:
				return null;
		}
	}

	public String shareOfTotalString(int ngram) {
		if (ngram == 0) {
			return "Delež glede na skupno vsoto vseh najdenih črkovnih nizov";
		}
		switch(this){
			case WORD:
				return "Delež glede na vse najdene različnice";
			case NORMALIZED_WORD:
				return "Delež glede na vse najdene normalizirane različnice";
			case LEMMA:
				return "Delež glede na vse najdene leme";
			case MORPHOSYNTACTIC_SPECS:
				return "Delež glede na vse najdene oblikoskladenjske oznake";
			case MORPHOSYNTACTIC_PROPERTY:
				return "Delež glede na vse najdene oblikoskladenjske lastnosti";
			case WORD_TYPE:
				return "Delež glede na vse najdene besedne vrste";
			case DIST_WORDS:
				return "Delež glede na vse najdene različnice";
			case DIST_LEMMAS:
				return "Delež glede na vse najdene leme";
			default:
				return null;
		}
	}

	public String toHeaderString(int ngram) {
		if (ngram == 0) {
			return "Črkovni niz";
		} else if (ngram == 1) {
			switch (this) {
				case WORD:
					return "Različnica";
				case NORMALIZED_WORD:
					return "Normalizirana različnica";
				case LEMMA:
					return "Lema";
				case MORPHOSYNTACTIC_SPECS:
					return "Oblikoskladenjska oznaka";
				case MORPHOSYNTACTIC_PROPERTY:
					return "Oblikoskladenjska lastnost";
				case WORD_TYPE:
					return "Besedna vrsta";
				case DIST_WORDS:
					return "Različnica";
				case DIST_LEMMAS:
					return "Lema";
				default:
					return null;
			}
		}
		switch (this) {
			case WORD:
			case DIST_WORDS:
				return "Različnica niza";
			case NORMALIZED_WORD:
				return "Normalizirana različnica niza";
			case LEMMA:
			case DIST_LEMMAS:
				return "Lema niza";
			case MORPHOSYNTACTIC_SPECS:
				return "Oblikoskladenjska oznaka niza";
			case MORPHOSYNTACTIC_PROPERTY:
				return "Oblikoskladenjska lastnost niza";
			case WORD_TYPE:
				return "Besedna vrsta niza";
			default:
				return null;
		}
	}

//    public String toPercentString() {
//        switch(this){
//            case WORD:
//                return "Delež glede na vse različnice";
//            case NORMALIZED_WORD:
//                return "Delež glede na vse normalizirane različnice";
//            case LEMMA:
//                return "Delež glede na vse leme";
//            case MORPHOSYNTACTIC_SPECS:
//                return "Delež glede na vse oblikoskladenjske oznake";
//            case MORPHOSYNTACTIC_PROPERTY:
//                return "Delež glede na vse oblikoskladenjske lastnosti";
//            case WORD_TYPE:
//                return "Delež glede na vse besedne vrste";
//            case DIST_WORDS:
//                return "Delež glede na vse različnice";
//            case DIST_LEMMAS:
//                return "Delež glede na vse leme";
//            default:
//                return null;
//        }
//    }
}
